Index: kernel/classes/notification/ezmailnotificationtransport.php
===================================================================
--- kernel/classes/notification/ezmailnotificationtransport.php	(revision 24126)
+++ kernel/classes/notification/ezmailnotificationtransport.php	(working copy)
@@ -66,6 +66,15 @@
         if ( !$emailSender )
             $emailSender = $ini->variable( "MailSettings", "AdminEmail" );
 
+		if ( $tpl->hasVariable( 'extra_headers' ) )
+		{
+			foreach( $tpl->variable( 'extra_headers' ) as $header )
+			{
+				$headerInfo = split( ';', $header, 2 );
+				$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+			}
+		}
+
         foreach ( $addressList as $addressItem )
         {
             $mail->extractEmail( $addressItem, $email, $name );
Index: kernel/classes/confirmorderhandlers/ezdefaultconfirmorderhandler.php
===================================================================
--- kernel/classes/confirmorderhandlers/ezdefaultconfirmorderhandler.php	(revision 24126)
+++ kernel/classes/confirmorderhandlers/ezdefaultconfirmorderhandler.php	(working copy)
@@ -79,6 +79,15 @@
             if ( $tpl->hasVariable( 'content_type' ) )
                 $mail->setContentType( $tpl->variable( 'content_type' ) );
 
+			if ( $tpl->hasVariable( 'extra_headers' ) )
+			{
+				foreach( $tpl->variable( 'extra_headers' ) as $header )
+				{
+					$headerInfo = split( ';', $header, 2 );
+					$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+				}
+			}
+
             $mail->setReceiver( $email );
             $mail->setSender( $emailSender );
             $mail->setSubject( $subject );
@@ -92,6 +101,15 @@
             if ( $tpl->hasVariable( 'content_type' ) )
                 $mail->setContentType( $tpl->variable( 'content_type' ) );
 
+			if ( $tpl->hasVariable( 'extra_headers' ) )
+			{
+				foreach( $tpl->variable( 'extra_headers' ) as $header )
+				{
+					$headerInfo = split( ';', $header, 2 );
+					$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+				}
+			}
+
             $mail->setReceiver( $email );
             $mail->setSender( $emailSender );
             $mail->setSubject( $subject );
Index: kernel/content/collectinformation.php
===================================================================
--- kernel/content/collectinformation.php	(revision 24126)
+++ kernel/content/collectinformation.php	(working copy)
@@ -297,6 +297,15 @@
             if ( $tpl->hasVariable( 'content_type' ) )
                 $mail->setContentType( $tpl->variable( 'content_type' ) );
 
+			if ( $tpl->hasVariable( 'extra_headers' ) )
+			{
+				foreach( $tpl->variable( 'extra_headers' ) as $header )
+				{
+					$headerInfo = split( ';', $header, 2 );
+					$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+				}
+			}
+
             if ( !$mail->validate( $receiver ) )
             {
                 $receiver = $ini->variable( "InformationCollectionSettings", "EmailReceiver" );
Index: kernel/content/tipafriend.php
===================================================================
--- kernel/content/tipafriend.php	(revision 24126)
+++ kernel/content/tipafriend.php	(working copy)
@@ -166,6 +166,15 @@
         if ( $mailtpl->hasVariable( 'content_type' ) )
             $mail->setContentType( $mailtpl->variable( 'content_type' ) );
 
+		if ( $tpl->hasVariable( 'extra_headers' ) )
+		{
+			foreach( $tpl->variable( 'extra_headers' ) as $header )
+			{
+				$headerInfo = split( ';', $header, 2 );
+				$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+			}
+		}
+
         $mail->setBody( $mailtext );
 
         // mail was sent ok
Index: kernel/user/forgotpassword.php
===================================================================
--- kernel/user/forgotpassword.php	(revision 24126)
+++ kernel/user/forgotpassword.php	(working copy)
@@ -95,6 +95,14 @@
             $subject = $tpl->variable( 'subject' );
         if ( $tpl->hasVariable( 'content_type' ) )
             $mail->setContentType( $tpl->variable( 'content_type' ) );
+		if ( $tpl->hasVariable( 'extra_headers' ) )
+		{
+			foreach( $tpl->variable( 'extra_headers' ) as $header )
+			{
+				$headerInfo = split( ';', $header, 2 );
+				$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+			}
+		}
         $mail->setSubject( $subject );
         $mail->setBody( $templateResult );
         $mailResult = eZMailTransport::send( $mail );
@@ -171,6 +179,14 @@
             $templateResult = $tpl->fetch( 'design:user/forgotpasswordmail.tpl' );
             if ( $tpl->hasVariable( 'content_type' ) )
                 $mail->setContentType( $tpl->variable( 'content_type' ) );
+			if ( $tpl->hasVariable( 'extra_headers' ) )
+			{
+				foreach( $tpl->variable( 'extra_headers' ) as $header )
+				{
+					$headerInfo = split( ';', $header, 2 );
+					$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+				}
+			}
             $emailSender = $ini->variable( 'MailSettings', 'EmailSender' );
             if ( !$emailSender )
                 $emailSender = $ini->variable( 'MailSettings', 'AdminEmail' );
Index: kernel/user/register.php
===================================================================
--- kernel/user/register.php	(revision 24126)
+++ kernel/user/register.php	(working copy)
@@ -259,6 +259,14 @@
                 $templateResult = $tpl->fetch( 'design:user/registrationinfo.tpl' );
                 if ( $tpl->hasVariable( 'content_type' ) )
                     $mail->setContentType( $tpl->variable( 'content_type' ) );
+				if ( $tpl->hasVariable( 'extra_headers' ) )
+				{
+					foreach( $tpl->variable( 'extra_headers' ) as $header )
+					{
+						$headerInfo = split( ';', $header, 2 );
+						$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+					}
+				}
                 $emailSender = $ini->variable( 'MailSettings', 'EmailSender' );
                 if ( !$emailSender )
                     $emailSender = $ini->variable( 'MailSettings', 'AdminEmail' );
@@ -289,6 +297,14 @@
 
                         if ( $tpl->hasVariable( 'content_type' ) )
                             $mail->setContentType( $tpl->variable( 'content_type' ) );
+						if ( $tpl->hasVariable( 'extra_headers' ) )
+						{
+							foreach( $tpl->variable( 'extra_headers' ) as $header )
+							{
+								$headerInfo = split( ';', $header, 2 );
+								$mail->addExtraHeader( $headerInfo[0], $headerInfo[1] );
+							}
+						}
 
                         $feedbackReceiver = $ini->variable( 'UserSettings', 'RegistrationEmail' );
                         if ( !$feedbackReceiver )