Index: extension/ezsurvey/modules/survey/classes/ezsurveyemailentry.php
--- extension/ezsurvey/modules/survey/classes/ezsurveyemailentry.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveyemailentry.php	(working copy)
@@ -104,6 +104,7 @@
     }
 }
 
-eZSurveyQuestion::registerQuestionType( 'Email Entry', 'EmailEntry' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Email Entry' ),
+                                        'EmailEntry' );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveynumberentry.php
--- extension/ezsurvey/modules/survey/classes/ezsurveynumberentry.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveynumberentry.php	(working copy)
@@ -419,6 +419,7 @@
     }
 }
 
-eZSurveyQuestion::registerQuestionType( 'Number Entry', 'NumberEntry' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Number Entry' ),
+                                        'NumberEntry' );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveyparagraph.php
--- extension/ezsurvey/modules/survey/classes/ezsurveyparagraph.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveyparagraph.php	(working copy)
@@ -53,6 +53,6 @@
     }
 }
 
-eZSurveyQuestion::registerQuestionType( 'Paragraph', 'Paragraph' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Paragraph' ), 'Paragraph' );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveyreceiver.php
--- extension/ezsurvey/modules/survey/classes/ezsurveyreceiver.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveyreceiver.php	(working copy)
@@ -400,6 +400,7 @@
     var $OptionID=0;
 }
 
-eZSurveyQuestion::registerQuestionType( 'Form Receiver', 'Receiver', true );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Form Receiver' ),
+                                        'Receiver', true );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveyrelatedobject.php
--- extension/ezsurvey/modules/survey/classes/ezsurveyrelatedobject.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveyrelatedobject.php	(working copy)
@@ -343,6 +343,7 @@
     }
 }
 
-eZSurveyQuestion::registerQuestionType( 'Related object', 'RelatedObject' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Related object' ),
+                                        'RelatedObject' );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveysectionheader.php
--- extension/ezsurvey/modules/survey/classes/ezsurveysectionheader.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveysectionheader.php	(working copy)
@@ -62,6 +62,7 @@
     }
 }
 
-eZSurveyQuestion::registerQuestionType( 'Section Header', 'SectionHeader' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Section Header' ),
+                                        'SectionHeader' );
 
 ?>
Index: extension/ezsurvey/modules/survey/classes/ezsurveytextentry.php
--- extension/ezsurvey/modules/survey/classes/ezsurveytextentry.php	(2.1.1)
+++ extension/ezsurvey/modules/survey/classes/ezsurveytextentry.php	(working copy)
@@ -93,6 +93,6 @@
 
 
 
-eZSurveyQuestion::registerQuestionType( 'Text Entry', 'TextEntry' );
+eZSurveyQuestion::registerQuestionType( ezi18n( 'survey', 'Text Entry' ), 'TextEntry' );
 
 ?>
Index: extension/ezsurvey/design/standard/templates/survey/edit/relatedobject.tpl
--- extension/ezsurvey/design/standard/templates/survey/edit/relatedobject.tpl	(2.1.1)
+++ extension/ezsurvey/design/standard/templates/survey/edit/relatedobject.tpl	(working copy)
@@ -3,17 +3,17 @@
 {def $surveyobject=fetch('content','object', hash('object_id', $question.num))}
 {content_view_gui content_object=$surveyobject view='survey'}
 <div class="block">
-    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_remove]" value="{'Remove'}" />
+    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_remove]" value="{'Remove'|i18n( 'survey' )}" />
     <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_edit]" value="{'Edit'|i18n( 'survey' )}" />&nbsp;
-    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_existing]" value="{'Add existing'}" />
+    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_existing]" value="{'Add existing'|i18n( 'survey' )}" />
     <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_new]" value="{'Add new'|i18n( 'survey' )}" disabled="disabled" />
 </div>
     {else}
 <p>{"Enter the button 'Add existing' or 'Add new' to create a new related object to the survey."|i18n( 'survey' )}</p>
 <div class="block">
-    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_remove]" value="{'Remove'}" disabled="disabled" />
+    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_remove]" value="{'Remove'|i18n( 'survey' )}" disabled="disabled" />
     <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_edit]" value="{'Edit'|i18n( 'survey' )}" disabled="disabled" />&nbsp;
-    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_existing]" value="{'Add existing'}" />
+    <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_existing]" value="{'Add existing'|i18n( 'survey' )}" />
     <input class="button" type="submit" name="CustomActionButton[{$attribute_id}_ezsurvey_related_object_{$question.id}_add_new]" value="{'Add new'|i18n( 'survey' )}" />
 </div>
 {/if}
Index: extension/ezsurvey/design/standard/templates/survey/result.tpl
--- extension/ezsurvey/design/standard/templates/survey/result.tpl	(2.1.1)
+++ extension/ezsurvey/design/standard/templates/survey/result.tpl	(working copy)
@@ -15,7 +15,7 @@
 <div class="survey-submenu float-break">
 <ul>
 <li><span class="current">{"Summary"|i18n('survey')}</span></li>
-<li><a href={concat('/survey/result_list/', $contentobject_id, '/', $contentclassattribute_id, '/', $language_code)|ezurl}>All evaluations</a></li>
+<li><a href={concat('/survey/result_list/', $contentobject_id, '/', $contentclassattribute_id, '/', $language_code)|ezurl}>{"All evaluations"|i18n('survey')}</a></li>
 </ul>
 </div>
 
Index: extension/ezsurvey/design/standard/templates/survey/result_list.tpl
--- extension/ezsurvey/design/standard/templates/survey/result_list.tpl	(2.1.1)
+++ extension/ezsurvey/design/standard/templates/survey/result_list.tpl	(working copy)
@@ -17,8 +17,8 @@
 
 <div class="survey-submenu float-break">
 <ul>
-<li><a href={concat('/survey/result/', $contentobject_id, '/', $contentclassattribute_id, '/', $language_code)|ezurl}>Summary</a></li>
-<li><span class="current">All evaluations</span></li>
+<li><a href={concat('/survey/result/', $contentobject_id, '/', $contentclassattribute_id, '/', $language_code)|ezurl}>{"Summary"|i18n('survey')}</a></li>
+<li><span class="current">{"All evaluations"|i18n('survey')}</span></li>
 </ul>
 </div>
 