Index: kernel/classes/datatypes/ezobjectrelationlist/ezobjectrelationlisttype.php
===================================================================
--- kernel/classes/datatypes/ezobjectrelationlist/ezobjectrelationlisttype.php	(revision 85)
+++ kernel/classes/datatypes/ezobjectrelationlist/ezobjectrelationlisttype.php	(working copy)
@@ -424,7 +424,7 @@
                 }
             }
         }
-        return eZObjectRelationListType::storeObjectAttributeContent( $attribute, $content );
+        return $this->storeObjectAttributeContent( $attribute, $content );
     }
 
     /*!
@@ -499,7 +499,7 @@
                 $content['relation_list'][$key]['is_modified'] = false;
             }
         }
-        eZObjectRelationListType::storeObjectAttributeContent( $contentObjectAttribute, $content );
+        $this->storeObjectAttributeContent( $contentObjectAttribute, $content );
         $contentObjectAttribute->setContent( $content );
         $contentObjectAttribute->store();
     }
@@ -520,7 +520,7 @@
 
             if ( $contentObjectID != $originalContentObjectID )
             {
-                $classContent = eZObjectRelationListType::defaultClassAttributeContent();
+                $classContent = $this->defaultClassAttributeContent();
                 if ( !$classContent['default_placement'] )
                 {
                     $content = $originalContentObjectAttribute->content();
@@ -647,8 +647,8 @@
         $xmlText = $classAttribute->attribute( 'data_text5' );
         if ( trim( $xmlText ) == '' )
         {
-            $content = eZObjectRelationListType::defaultClassAttributeContent();
-            return eZObjectRelationListType::storeClassAttributeContent( $classAttribute, $content );
+            $content = $this->defaultClassAttributeContent();
+            return $this->storeClassAttributeContent( $classAttribute, $content );
         }
     }
 
@@ -658,7 +658,7 @@
     function preStoreClassAttribute( $classAttribute, $version )
     {
         $content = $classAttribute->content();
-        return eZObjectRelationListType::storeClassAttributeContent( $classAttribute, $content );
+        return $this->storeClassAttributeContent( $classAttribute, $content );
     }
 
     function storeClassAttributeContent( $classAttribute, $content )
@@ -665,8 +665,8 @@
     {
         if ( is_array( $content ) )
         {
-            $doc = eZObjectRelationListType::createClassDOMDocument( $content );
-            eZObjectRelationListType::storeClassDOMDocument( $doc, $classAttribute );
+            $doc = $this->createClassDOMDocument( $content );
+            $this->storeClassDOMDocument( $doc, $classAttribute );
             return true;
         }
         return false;
@@ -676,8 +676,8 @@
     {
         if ( is_array( $content ) )
         {
-            $doc = eZObjectRelationListType::createObjectDOMDocument( $content );
-            eZObjectRelationListType::storeObjectDOMDocument( $doc, $objectAttribute );
+            $doc = $this->createObjectDOMDocument( $content );
+            $this->storeObjectDOMDocument( $doc, $objectAttribute );
             return true;
         }
         return false;
@@ -685,7 +685,7 @@
 
     function storeClassDOMDocument( $doc, $classAttribute )
     {
-        $docText = eZObjectRelationListType::domString( $doc );
+        $docText = $this->domString( $doc );
         $classAttribute->setAttribute( 'data_text5', $docText );
     }
 
@@ -691,7 +691,7 @@
 
     function storeObjectDOMDocument( $doc, $objectAttribute )
     {
-        $docText = eZObjectRelationListType::domString( $doc );
+        $docText = $this->domString( $doc );
         $objectAttribute->setAttribute( 'data_text', $docText );
     }
 
@@ -761,7 +761,7 @@
         $doc = new DOMDocument();
         $root = $doc->createElement( 'related-objects' );
         $relationList = $doc->createElement( 'relation-list' );
-        $attributeDefinitions = eZObjectRelationListType::contentObjectArrayXMLMap();
+        $attributeDefinitions = $this->contentObjectArrayXMLMap();
 
         foreach ( $content['relation_list'] as $relationItem )
         {
@@ -812,7 +812,7 @@
             $db->begin();
             foreach ( $content['relation_list'] as $deletionItem )
             {
-                eZObjectRelationListType::removeRelationObject( $objectAttribute, $deletionItem );
+                $this->removeRelationObject( $objectAttribute, $deletionItem );
             }
             $db->commit();
         }
@@ -863,7 +863,7 @@
                     if ( isset( $nodePlacementMap[$contentObjectAttribute->attribute( 'id' )] ) )
                         $nodePlacement = $nodePlacementMap[$contentObjectAttribute->attribute( 'id' )];
                 }
-                $relationItem = eZObjectRelationListType::createInstance( $class,
+                $relationItem = $this->createInstance( $class,
                                                                           $priority + 1,
                                                                           $contentObjectAttribute,
                                                                           $nodePlacement );
@@ -953,7 +953,7 @@
                 {
                     if ( in_array( $relationItem['contentobject_id'], $selections ) )
                     {
-                        eZObjectRelationListType::removeRelationObject( $contentObjectAttribute, $relationItem );
+                        $this->removeRelationObject( $contentObjectAttribute, $relationItem );
                     }
                     else
                     {
@@ -1117,7 +1117,7 @@
     */
     function removeRelationObject( $contentObjectAttribute, $deletionItem )
     {
-        if ( eZObjectRelationListType::isItemPublished( $deletionItem ) )
+        if ( self::isItemPublished( $deletionItem ) )
         {
             return;
         }
@@ -1227,7 +1227,7 @@
         {
             case 'move':
             {
-                eZObjectRelationListType::fixRelationsMove( $objectID, $contentObjectAttribute );
+                $this->fixRelationsMove( $objectID, $contentObjectAttribute );
             } break;
 
             case 'trash':
@@ -1232,7 +1232,7 @@
 
             case 'trash':
             {
-                eZObjectRelationListType::fixRelationsTrash( $objectID, $contentObjectAttribute );
+                $this->fixRelationsTrash( $objectID, $contentObjectAttribute );
             } break;
 
             case 'restore':
@@ -1237,7 +1237,7 @@
 
             case 'restore':
             {
-                eZObjectRelationListType::fixRelationsRestore( $objectID, $contentObjectAttribute );
+                $this->fixRelationsRestore( $objectID, $contentObjectAttribute );
             } break;
 
             case 'remove':
@@ -1242,7 +1242,7 @@
 
             case 'remove':
             {
-                eZObjectRelationListType::fixRelationsRemove( $objectID, $contentObjectAttribute );
+                $this->fixRelationsRemove( $objectID, $contentObjectAttribute );
             } break;
 
             case 'swap':
@@ -1247,7 +1247,7 @@
 
             case 'swap':
             {
-                eZObjectRelationListType::fixRelationsSwap( $objectID, $contentObjectAttribute );
+                $this->fixRelationsSwap( $objectID, $contentObjectAttribute );
             } break;
 
             default:
@@ -1274,7 +1274,7 @@
                 $content['relation_list'][$key]['parent_node_id']= null;
             }
         }
-        eZObjectRelationListType::storeObjectAttributeContent( $contentObjectAttribute, $content );
+        $this->storeObjectAttributeContent( $contentObjectAttribute, $content );
         $contentObjectAttribute->setContent( $content );
         $contentObjectAttribute->storeData();
     }
@@ -1291,7 +1291,7 @@
                 $content['relation_list'][$key] = $this->appendObject( $objectID, $priority, $contentObjectAttribute);
             }
         }
-        eZObjectRelationListType::storeObjectAttributeContent( $contentObjectAttribute, $content );
+        $this->storeObjectAttributeContent( $contentObjectAttribute, $content );
         $contentObjectAttribute->setContent( $content );
         $contentObjectAttribute->storeData();
     }
@@ -1316,7 +1316,7 @@
             }
         }
 
-        eZObjectRelationListType::storeObjectAttributeContent( $contentObjectAttribute, $content );
+        $this->storeObjectAttributeContent( $contentObjectAttribute, $content );
         $contentObjectAttribute->setContent( $content );
         $contentObjectAttribute->storeData();
     }
@@ -1330,11 +1330,11 @@
         $xmlText = $contentObjectAttribute->attribute( 'data_text' );
         if ( trim( $xmlText ) == '' )
         {
-            $objectAttributeContent = eZObjectRelationListType::defaultObjectAttributeContent();
+            $objectAttributeContent = $this->defaultObjectAttributeContent();
             return $objectAttributeContent;
         }
-        $doc = eZObjectRelationListType::parseXML( $xmlText );
-        $content = eZObjectRelationListType::createObjectContentStructure( $doc );
+        $doc = $this->parseXML( $xmlText );
+        $content = $this->createObjectContentStructure( $doc );
 
         return $content;
     }
@@ -1347,10 +1347,10 @@
         $xmlText = $classAttribute->attribute( 'data_text5' );
         if ( trim( $xmlText ) == '' )
         {
-            return eZObjectRelationListType::defaultClassAttributeContent();
+            return $this->defaultClassAttributeContent();
         }
-        $doc = eZObjectRelationListType::parseXML( $xmlText );
-        return eZObjectRelationListType::createClassContentStructure( $doc );
+        $doc = $this->parseXML( $xmlText );
+        return $this->createClassContentStructure( $doc );
     }
 
     function parseXML( $xmlText )
@@ -1376,7 +1376,7 @@
 
     function createClassContentStructure( $doc )
     {
-        $content = eZObjectRelationListType::defaultClassAttributeContent();
+        $content = $this->defaultClassAttributeContent();
         $root = $doc->documentElement;
         $objectPlacement = $root->getElementsByTagName( 'contentobject-placement' )->item( 0 );
 
@@ -1415,7 +1415,7 @@
 
     function createObjectContentStructure( $doc )
     {
-        $content = eZObjectRelationListType::defaultObjectAttributeContent();
+        $content = $this->defaultObjectAttributeContent();
         $root = $doc->documentElement;
         $relationList = $root->getElementsByTagName( 'relation-list' )->item( 0 );
         if ( $relationList )
@@ -1420,7 +1420,7 @@
         $relationList = $root->getElementsByTagName( 'relation-list' )->item( 0 );
         if ( $relationList )
         {
-            $contentObjectArrayXMLMap = eZObjectRelationListType::contentObjectArrayXMLMap();
+            $contentObjectArrayXMLMap = $this->contentObjectArrayXMLMap();
             $relationItems = $relationList->getElementsByTagName( 'relation-item' );
             foreach ( $relationItems as $relationItem )
             {
@@ -1538,7 +1538,7 @@
     {
         $objectIDList = explode( '-', $string );
 
-        $content = eZObjectRelationListType::defaultObjectAttributeContent();
+        $content = $this->defaultObjectAttributeContent();
         $priority = 0;
         foreach( $objectIDList as $objectID )
         {
@@ -1772,7 +1772,7 @@
         $xmlText = $contentObjectAttribute->attribute( 'data_text' );
         if ( trim( $xmlText ) == '' ) return;
 
-        $doc = eZObjectRelationListType::parseXML( $xmlText );
+        $doc = $this->parseXML( $xmlText );
 
         $return = false;
         $root = $doc->documentElement;
@@ -1792,7 +1792,7 @@
                 }
             }
         }
-        eZObjectRelationListType::storeObjectDOMDocument( $doc, $contentObjectAttribute );
+        $this->storeObjectDOMDocument( $doc, $contentObjectAttribute );
         return $return;
     }
 
@@ -1801,4 +1801,4 @@
 
 eZDataType::register( eZObjectRelationListType::DATA_TYPE_STRING, "eZObjectRelationListType" );
 
-?>
+?>
\ No newline at end of file