Index: .
===================================================================
--- .	(revision 21370)
+++ .	(working copy)
@@ -1253,7 +1253,12 @@
     */
     function fetchVirtualSiteContent( $site, $depth, $properties )
     {
-        $this->appendLogEntry( "Script URL.." . $_SERVER["SCRIPT_URL"], 'CS:fetchVirtualSiteContent' );
+
+        // replace $_SERVER["SCRIPT_URL"] beacaus some webservers e.g. lighttpd in fcgi mode does not
+        // set this php server variable
+        $scriptURL = $_SERVER["REQUEST_URI"] . '/';
+
+        $this->appendLogEntry( "Script URL.." . $scriptURL, 'CS:fetchVirtualSiteContent' );
         // Location of the info file.
         $infoFile = $_SERVER['DOCUMENT_ROOT'] . '/' . eZWebDAVContentServer::virtualInfoFileName();
 
@@ -1259,7 +1264,7 @@
 
         // Always add the current collection
         $contentEntry = array();
-        $contentEntry["name"]     = $_SERVER["SCRIPT_URL"];
+        $contentEntry["name"]     = $scriptURL;
         $contentEntry["size"]     = 0;
         $contentEntry["mimetype"] = 'httpd/unix-directory';
         $contentEntry["ctime"]    = filectime( 'settings/siteaccess/' . $site );
@@ -1264,7 +1269,7 @@
         $contentEntry["mimetype"] = 'httpd/unix-directory';
         $contentEntry["ctime"]    = filectime( 'settings/siteaccess/' . $site );
         $contentEntry["mtime"]    = filemtime( 'settings/siteaccess/' . $site );
-        $contentEntry["href"]     = $_SERVER["SCRIPT_URL"];
+        $contentEntry["href"]     = $scriptURL;
         $entries[] = $contentEntry;
 
         $defctime = $contentEntry['ctime'];
@@ -1272,7 +1277,7 @@
 
         if ( $depth > 0 )
         {
-            $scriptURL = $_SERVER["SCRIPT_URL"];
+            //$scriptURL = $scriptURL;
             if ( $scriptURL{strlen($scriptURL) - 1} != "/" )
                 $scriptURL .= "/";
 
@@ -1321,6 +1326,8 @@
     */
     function fetchSiteListContent( $depth, $properties )
     {
+        $scriptURL = $_SERVER["REQUEST_URI"] . '/';
+
         // At the end: we'll return an array of entry-arrays.
         $entries = array();
 
@@ -1330,7 +1337,7 @@
 
         // Set up attributes for the virtual site-list folder:
         $contentEntry["name"]     = '/';
-        $contentEntry["href"]     = $_SERVER['SCRIPT_URL'];
+        $contentEntry["href"]     = $scriptURL;
         $contentEntry["size"]     = 0;
         $contentEntry["mimetype"] = 'httpd/unix-directory';
         $contentEntry["ctime"]    = filectime( 'var' );
@@ -1347,7 +1354,7 @@
             foreach ( $sites as $site )
             {
                 // Set up attributes for the virtual site-list folder:
-                $contentEntry["name"]     = $_SERVER['SCRIPT_URL'] . $site;
+                $contentEntry["name"]     = $scriptURL . $site;
                 $contentEntry["size"]     = 0;
                 $contentEntry["mimetype"] = 'httpd/unix-directory';
                 $contentEntry["ctime"]    = filectime( 'settings/siteaccess/' . $site );
@@ -1353,7 +1360,7 @@
                 $contentEntry["ctime"]    = filectime( 'settings/siteaccess/' . $site );
                 $contentEntry["mtime"]    = filemtime( 'settings/siteaccess/' . $site );
 
-                if ( $_SERVER["SCRIPT_URL"] == '/' )
+                if ( $scriptURL == '/' )
                 {
                     $contentEntry["href"] = $contentEntry["name"];
                 }
@@ -1359,7 +1366,7 @@
                 }
                 else
                 {
-                    $contentEntry["href"] = $_SERVER["SCRIPT_URL"] . $contentEntry["name"];
+                    $contentEntry["href"] = $scriptURL . $contentEntry["name"];
                 }
 
                 $entries[] = $contentEntry;
@@ -1376,6 +1383,8 @@
     */
     function fetchContentList( &$node, $target, $depth, $properties )
     {
+        $scriptURL = $_SERVER["REQUEST_URI"] . '/';
+
         // We'll return an array of entries (which is an array of attributes).
         $entries = array();
 
@@ -1395,7 +1404,7 @@
         // Always include the information about the current level node
         $thisNodeInfo = array();
         $thisNodeInfo = $this->fetchNodeInfo( $node );
-        $thisNodeInfo["href"] = $_SERVER['SCRIPT_URL'];
+        $thisNodeInfo["href"] = $scriptURL;
         $entries[] = $thisNodeInfo;
 
         // Return the content of the target.
@@ -1427,6 +1436,9 @@
     */
     function fetchNodeInfo( &$node )
     {
+
+        $scriptURL = $_SERVER["REQUEST_URI"] . '/';
+
         // When finished, we'll return an array of attributes/properties.
         $entry = array();
 
@@ -1512,7 +1524,7 @@
             }
         }
 
-        $scriptURL = $_SERVER["SCRIPT_URL"];
+        $scriptURL = $scriptURL;
         if ( strlen( $scriptURL ) > 0 and $scriptURL[ strlen( $scriptURL ) - 1 ] != "/" )
             $scriptURL .= "/";
 
@@ -1616,7 +1628,7 @@
 
     static function virtualContentFolderName()
     {
-        return ezi18n( 'kernel/content', "Content" );
+        return ezi18n( 'kernel/content', "content" );
     }
 
     static function virtualMediaFolderName()
@@ -1621,7 +1633,7 @@
 
     static function virtualMediaFolderName()
     {
-        return ezi18n( 'kernel/content', "Media" );
+        return ezi18n( 'kernel/content', "media" );
     }
 
     static function virtualInfoFileName()