Index: packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl
===================================================================
--- packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl	(revision 3957)
+++ packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl	(working copy)
@@ -12,14 +12,28 @@
                                                 class_filter_type, include,
                                                 class_filter_array, array( 'forum_topic' ),
                                                 limit, 1,
-                                                attribute_filter, array( and, array( 'modified_subnode', '<', $node.modified_subnode ) ),
-                                                sort_by, array( array( 'modified_subnode', false() ) ) ) )
+                                                attribute_filter, array( and,
+                                                                         array( 'forum_topic/sticky', '<=', $node.data_map.sticky.data_int ),
+                                                                         array( 'modified_subnode', '<=', $node.modified_subnode ),
+                                                                         array( 'name', '<=', $node.name ),
+                                                                         array( 'path', '!=', $node.path_string ) ),
+                                                sort_by, array( array( 'attribute', false(), 'forum_topic/sticky' ),
+                                                                array( 'modified_subnode', false() ),
+                                                                array( 'name', false() ),
+                                                                array( 'path', false() ) ) ) )
      next_topic=fetch_alias( subtree, hash( parent_node_id, $node.parent_node_id,
                                             class_filter_type, include,
                                             class_filter_array, array( 'forum_topic' ),
                                             limit, 1,
-                                            attribute_filter, array( and, array( 'modified_subnode', '>', $node.modified_subnode ) ),
-                                            sort_by, array( array( 'modified_subnode', true() ) ) ) ) }
+                                            attribute_filter, array( and,
+                                                                     array( 'forum_topic/sticky', '>=', $node.data_map.sticky.data_int ),
+                                                                     array( 'modified_subnode', '>=', $node.modified_subnode ),
+                                                                     array( 'name', '>=', $node.name ),
+                                                                     array( 'path', '!=', $node.path_string ) ),
+                                            sort_by, array( array( 'attribute', true(), 'forum_topic/sticky' ),
+                                                            array( 'modified_subnode', true() ),
+                                                            array( 'name', true() ),
+                                                            array( 'path', true() ) ) ) ) }
 
 
 <div class="border-box">
Index: packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl
===================================================================
--- packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl	(revision 3957)
+++ packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl	(working copy)
@@ -2,7 +2,10 @@
      $topic_list = fetch( 'content', 'list', hash( 'parent_node_id', $node.node_id,
                                                   'limit', $page_limit,
                                                   'offset', $view_parameters.offset,
-                                                  'sort_by', array( array( attribute, false(), 'forum_topic/sticky' ), array( 'modified_subnode', false() ) ) ) )
+                                                  'sort_by', array( array( 'attribute', true(), 'forum_topic/sticky' ),
+                                                                    array( 'modified_subnode', true() ),
+                                                                    array( 'name', true() ),
+                                                                    array( 'path', true() ) ) ) )
      $topic_count = fetch( 'content', 'list_count', hash( 'parent_node_id', $node.node_id ) )}
 
 <div class="border-box">