Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum.tpl	(working copy)
@@ -2,7 +2,7 @@
      $topic_list = fetch( 'content', 'list', hash( 'parent_node_id', $node.node_id,
                                                   'limit', $page_limit,
                                                   'offset', $view_parameters.offset,
-                                                  'sort_by', array( array( attribute, false(), 'forum_topic/sticky' ), array( 'modified_subnode', false() ) ) ) )
+                                                  'sort_by', array( array( attribute, false(), 'forum_topic/sticky' ), array( 'modified_subnode', false() ), array( 'node_id', false() ) ) ) )
      $topic_count = fetch( 'content', 'list_count', hash( 'parent_node_id', $node.node_id ) )}
 
 <div class="border-box">
Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forum_topic.tpl	(working copy)
@@ -13,13 +13,13 @@
                                                 class_filter_array, array( 'forum_topic' ),
                                                 limit, 1,
                                                 attribute_filter, array( and, array( 'modified_subnode', '<', $node.modified_subnode ) ),
-                                                sort_by, array( array( 'modified_subnode', false() ) ) ) )
+                                                'sort_by', array( array( 'modified_subnode', false() ), array( 'node_id', false() ) ) ) )
      next_topic=fetch_alias( subtree, hash( parent_node_id, $node.parent_node_id,
                                             class_filter_type, include,
                                             class_filter_array, array( 'forum_topic' ),
                                             limit, 1,
                                             attribute_filter, array( and, array( 'modified_subnode', '>', $node.modified_subnode ) ),
-                                            sort_by, array( array( 'modified_subnode', true() ) ) ) ) }
+                                            'sort_by', array( array( 'modified_subnode', true() ), array( 'node_id', true() ) ) ) ) }
 
 
 <div class="border-box">
Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forums.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forums.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/forums.tpl	(working copy)
@@ -38,7 +38,7 @@
                 <td>{fetch('content','tree_count',hash(parent_node_id,$child.node_id))}</td>
                 <td class="last-reply">{def $topic_list=fetch_alias( children, hash( parent_node_id, $child.node_id,
                                                                                      limit, 1,
-                                                                                     sort_by, array( 'modified_subnode', false() ) ) )}
+                                                                                     'sort_by', array( array( 'modified_subnode', false() ), array( 'node_id', false() ) ) ) )}
                     {foreach $topic_list as $topic}
                          <a href={$topic.url_alias|ezurl}>{$topic.name}</a>
                         <p class="date">{$topic.object.published|l10n(shortdatetime)}</p>
Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/image.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/image.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/full/image.tpl	(working copy)
@@ -18,13 +18,13 @@
                                                        'class_filter_array', array( 'image' ),
                                                        'limit', '1',
                                                        'attribute_filter', array( 'and', array( $sort_column, $sort_order|choose( '>', '<' ), $sort_column_value ) ),
-                                                       'sort_by', array( $sort_column, $sort_order|not ) ) )
+                                                       'sort_by', array( array( $sort_column, $sort_order|not ), array( 'node_id', $sort_order|not ) ) ) )
      $next_image = fetch( 'content', 'list', hash( 'parent_node_id', $node.parent_node_id,
                                                    'class_filter_type', 'include',
                                                    'class_filter_array', array( 'image' ),
                                                    'limit', '1',
                                                    'attribute_filter', array( 'and', array( $sort_column, $sort_order|choose( '<', '>' ), $sort_column_value ) ),
-                                                   'sort_by', array( $sort_column, $sort_order ) ) ) }
+                                                   'sort_by', array( array( $sort_column, $sort_order ), array( 'node_id', $sort_order ) ) ) ) }
 
 <div class="border-box">
 <div class="border-tl"><div class="border-tr"><div class="border-tc"></div></div></div>
Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/itemizedsubitems/forum.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/itemizedsubitems/forum.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/itemizedsubitems/forum.tpl	(working copy)
@@ -19,10 +19,10 @@
         {set $offset = $object_parameters.offset}
     {/if}
 
-    {set $children=fetch( content, list, hash( 'parent_node_id', $object.main_node_id, 
-                                               'limit', $limit,
-                                               'offset', $offset,
-                                               'sort_by', array( 'modified_subnode', false() ) ) ) }
+    {set $children=fetch( 'content', 'list', hash( 'parent_node_id', $object.main_node_id, 
+                                                   'limit', $limit,
+                                                   'offset', $offset,
+                                                   'sort_by', array( array( 'modified_subnode', false() ), array( 'node_id', false() ) ) ) )}
 
     {if $children|count()}
     
Index: trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/line/forum.tpl
===================================================================
--- trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/line/forum.tpl	(revision 4048)
+++ trunk/packages/ezwebin_extension/ezextension/ezwebin/design/ezwebin/override/templates/line/forum.tpl	(working copy)
@@ -15,9 +15,9 @@
                     </div></td>
                 <td>{fetch('content','list_count',hash(parent_node_id,$node.node_id))}</td>
                 <td>{fetch('content','tree_count',hash(parent_node_id,$node.node_id))}</td>
-                <td> {let forum_list=fetch_alias( children, hash( parent_node_id, $node.node_id,
-                    limit, 4,
-                    sort_by, array( 'modified_subnode', false() ) ) )}
+                <td> {let forum_list = fetch_alias( 'children', hash( 'parent_node_id', $node.node_id,
+                                            'limit', 4,
+                                            'sort_by', array( array( 'modified_subnode', false() ), array( 'node_id', false() ) ) ) )}
                     <ul>
                         {section loop=$forum_list}
                         <li> {node_view_gui view=line content_node=$:item} </li>